
#include "global.h"

#define FIXED_CAM	0
#define Z_NEAR		1
#define Z_FAR		1000

using namespace std;

double RtoD = 57.2957795;
int WindowR::width  = 1390;   // set window width in pixels here
int WindowR::height = 800;   // set window height in pixels here
Camera cam;
Frustum f;
double angle = 0;
bool defaultShape = true;
Matrix4 tempM;
Matrix4 rotM;

//the root of our scene-graph
transformGroup* ROOT;
transformGroup* GLOBALROOT;
Light sun(0);

//Textures
GLuint grass_tex, road_tex, corner_tex, *bldg_tex;

//the camera pos, angle and lookat
double cam_angle = 90;
//cam hovers 5 units above ground, and starts @ 3,5 (behind the car)
double cam_x = 3, cam_y = 3.3, cam_z = -2;
//the lookat point, lies on unit circle around cam, starting looking down the x axis
double lookat_x = 3, lookat_y = 3.3, lookat_z = -3;


double mouseStartX = 0;
double mouseStartY = 0;
double mouseStartZ = 0;
bool WindowR::culling = false;
//double radius = sqrt((WindowR::width/2)*(WindowR::width/2)+(WindowR::height/2)*(WindowR::height/2));


double WindowR::dNear;
double WindowR::dFar;
double WindowR::dRight;
double WindowR::dLeft;
double WindowR::dTop;
double WindowR::dBottom;

Vector3 WindowR::pNear;
Vector3 WindowR::pFar;
Vector3 WindowR::pRight;
Vector3 WindowR::pLeft;
Vector3 WindowR::pTop;
Vector3 WindowR::pBottom;

Vector3 WindowR::nNear;
Vector3 WindowR::nFar;
Vector3 WindowR::nRight;
Vector3 WindowR::nLeft;
Vector3 WindowR::nTop;
Vector3 WindowR::nBottom;

    //double Hfar;
    //double Wfar;
double WindowR::Hnear;
double WindowR::Wnear;

unsigned char* textureData_car;
GLuint textureID[1];
int car_width = 1024;
int car_height = 1024;
transformGroup* car;
transformGroup* carRot;
Shape3D* firstCar;

bool collisionDetected;
bool trees = true;
bool buildings = true;

//int radius = WindowR::width;
//----------------------------------------------------------------------------
// Callback method called when system is idle.
void WindowR::idleCallback(void)
{
    /*
    angle += .00005;
    if (angle > 360.0 || angle < -360.0) angle = 0.0;
    //cout << angle << endl;
    Matrix4 mr;
    mr.rotateY(angle);
    houseM.multiplyInPlace(mr);*/
  //sphere.spin(1.0);       // rotate cube by 1 degree
  //displayCallback();    // call display routine to redraw cube
}

//----------------------------------------------------------------------------
// Callback method called when window is resized.
void WindowR::reshapeCallback(int w, int h)
{
  width = w;
  height = h;
  //radius = sqrt((w/2)*(w/2)+(h/2)*(h/2));//radius reaches corner of screen.
  glViewport(0, 0, w, h);  // set new viewport size

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
				//fovy, aspect, zNear, zFar
	gluPerspective(60.0, (double)((double)(w)/double(height)), Z_NEAR, Z_FAR);

  /*glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-10.0, 10.0, -10.0, 10.0, 10, 1000.0); // set perspective projection viewing frustum
  glTranslatef(0, 0, -10);
  glMatrixMode(GL_MODELVIEW);*/
  //f.setGLProjection();
  //houseCam.identity();
  //initRobot();
}

void setupCamera(){
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	if (FIXED_CAM)
		gluLookAt(	40.0, 80.0, 100.0, 		//eye position
				40.0, 10.0, -80.0, 		//lookat
				0.0, 1.0, 0.0);		//up vector
	else
		gluLookAt(	cam_x, cam_y, cam_z, 		//eye position
				lookat_x, lookat_y, lookat_z, 		//lookat
				0.0, 1.0, 0.0);		//up vector


}


#define AXIS_LENGTH 10
/****************************************************************************************/
void WindowR::drawReferenceAxis()
{
	 glPushAttrib(GL_ALL_ATTRIB_BITS);
						// Pushes attributes like current color to attribute stack.
	 glBegin(GL_LINES);
						// X axis red
      glColor3f(1, 0, 0);
      glVertex3f(0, 0, 0);
      glVertex3f(AXIS_LENGTH, 0, 0);
						// Y axis green
    glColor3f(0, 1, 0);
      glVertex3f(0, 0, 0);
      glVertex3f(0, AXIS_LENGTH, 0);
						// Z axis white
      glColor3f(1, 1, 1);
      glVertex3f(0, 0, 0);
      glVertex3f(0, 0, AXIS_LENGTH);

	glEnd();
	  glPopAttrib();
						// // Pops attributes like current color from the attribute stack and sets as current.
}

/******************************************************************************/

//----------------------------------------------------------------------------
// Callback method called when window redraw is necessary or
// when glutPostRedisplay() was called.
void WindowR::displayCallback(void)
{
  //bind null texture first
  //glBindTexture(GL_TEXTURE_2D,0);


  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);  // clear color and depth buffers
  glMatrixMode(GL_MODELVIEW);
  Matrix4 m;
  //houseCam = cam.cameraMatrix.multiply(tempM); // THIS MIGHT BE BACKWARDS...
	m.identity();
  //glLoadMatrixd(houseCam.getPointer()); //FIX THIS
  //cerr <<"about to draw"<<endl;
	setupCamera();
  	GLOBALROOT->draw(m);

	WindowR::drawReferenceAxis();

	glFlush();
  	glutSwapBuffers();
}


double diff(timespec start, timespec end)
{
    //return end.tv_nsec-start.tv_nsec;
    return (end.tv_sec+(((double)end.tv_nsec)/1000000000.0)-(start.tv_sec+(((double)start.tv_nsec)/1000000000.0)));
/*
        double timeDiff;
        timespec time1, time2;


        clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &time1);
        for(int i = 0;i<128; i++){
            rotM.rotateZ(i);
            tempM = rotM.multiply(houseM);

            glMatrixMode(GL_MODELVIEW);
            //houseM = tempM; // THIS MIGHT BE BACKWARDS...
            glLoadMatrixd(tempM.getPointer()); //FIX THIS
            WindowR::displayCallback();
        }
        rotM.identity();
        houseM = tempM;
        clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &time2);
        timeDiff = diff(time1,time2);
        if(culling){
            cout << "frames per second for culling: "<< (128.0/(timeDiff)) << endl;
        }else{
            cout << "frames per second no culling: "<< (128.0/(timeDiff)) << endl;
        }

	*/
}
void WindowR::keyboard(unsigned char key, int, int)
{
  cerr << "Key pressed: " << key << endl;
	//should really be using a switch here...
   switch(key){

	//move up
   	case 'w':
			cam_y += H_STEP;
			break;

	//move down
   	case 's':
			cam_y -= H_STEP;
			break;

	//strafe left
   	case 'a':

		//move cam to the left
		cam_x = cam_x + cos(d2r(cam_angle+90));
		cam_z = (cam_z - sin(d2r(cam_angle+90)));

		//calc new lookat position on unit circle
		lookat_x = cam_x + cos(d2r(cam_angle));
		lookat_z = (cam_z - sin(d2r(cam_angle)));
		break;

	//strafe right
   	case 'd':

		//move cam to the right, that is current_angle - 90
		cam_x = cam_x + cos(d2r(cam_angle-90));
		cam_z = (cam_z - sin(d2r(cam_angle-90)));

		//calc new lookat position on unit circle
		lookat_x = cam_x + cos(d2r(cam_angle));
		lookat_z = (cam_z - sin(d2r(cam_angle)));
		break;
   	case 'k':
        exit(EXIT_SUCCESS);
		break;
	//toggle collisions
   	case 'c':
			collisions = !collisions;
			if(collisions){
                cerr <<"collision detection on"<<endl;
            }else{
                cerr <<"collision detection off"<<endl;
            }
			break;

   	case 't':
			trees = !trees;
			if(trees){
                cerr <<"trees on"<<endl;
            }else{
                cerr <<"trees off"<<endl;
            }
			break;

   	case 'b':
			buildings = !buildings;
			if(buildings){
                cerr <<"buildings on"<<endl;
            }else{
                cerr <<"buildings off"<<endl;
            }
			break;

    }
	lookat_y = cam_y;

	glutPostRedisplay();

}

void WindowR::specialFunc(int k, int x, int y)
{
	double xdiff,zdiff;
	Matrix4 transM;
	Matrix4 carM;

    //save in case of a collision
	Matrix4 originalCar = car->getMatrix();
	Matrix4 originalCarRot = carRot->getMatrix();
    double original_cam_angle = cam_angle;
    double original_cam_x = cam_x, original_cam_y = cam_y, original_cam_z = cam_z;
    double original_lookat_x = lookat_x, original_lookat_y = lookat_y, original_lookat_z = lookat_z;

	switch(k) {
			//forward
	      case GLUT_KEY_UP:
            cerr << "Move: Forward" << endl;
			xdiff = lookat_x - cam_x;
			zdiff = lookat_z - cam_z;

			//x-change old lookat with the new cam position
			cam_x = lookat_x;
			cam_z = lookat_z;
            transM.translation(xdiff,0,zdiff);
            carM = carRot->getMatrix();
            transM.multiplyInPlace(carM);
            carRot->setMatrix(transM);
			break;

			//back
	      case GLUT_KEY_DOWN:
			//move backwards
			cerr << "Move: Backwards" << endl;
			xdiff = lookat_x - cam_x;
			zdiff = lookat_z - cam_z;
			cam_x -= lookat_x - cam_x;
			cam_z -= lookat_z - cam_z;

            transM.translation(-xdiff,0,-zdiff);
            carM = carRot->getMatrix();
            transM.multiplyInPlace(carM);
            carRot->setMatrix(transM);
			break;


			//turn left
	      case GLUT_KEY_LEFT:
            cerr << "Rotate: Left" << endl;
            //move up rotate and the move back??
			cam_angle += CAM_ROT_STEP;
			//if (cam_angle<0) cam_angle+=360;

            transM.rotateY(CAM_ROT_STEP);
            carM = car->getMatrix();
            transM.multiplyInPlace(carM);
            car->setMatrix(transM);
			break;

			//turn right
	      case GLUT_KEY_RIGHT:
	        cerr << "Rotate: Right" << endl;
			cam_angle -= CAM_ROT_STEP;
			//if (cam_angle<0) cam_angle+=360;

            transM.rotateY(-CAM_ROT_STEP);
            carM = car->getMatrix();
            transM.multiplyInPlace(carM);
            car->setMatrix(transM);
			break;
    }


    if(collisions){
        Matrix4 m;
        m.identity();

/*
        Matrix4 temp;
        Matrix4 carTransforms = GLOBALROOT->getMatrix();
        temp = carRot->getMatrix();
        carTransforms = temp.multiply(carTransforms);
        temp = car->getMatrix();
        carTransforms = temp.multiply(carTransforms);
*/
        Matrix4 temp= GLOBALROOT->getMatrix();
        Matrix4 carTransforms = carRot->getMatrix();
        carTransforms.multiplyInPlace(temp);
        temp = car->getMatrix();
        carTransforms.multiplyInPlace(temp);


        //m.multiply(transMatrix)
        //globalRoot,CarRot,Car,firstCar
        GLOBALROOT->detectCollision(firstCar,carTransforms,m);
    }
    cerr <<"Cval:"<<collisionDetected<<endl;
    if(collisionDetected == true && collisions){
        cerr <<"collision Detected!!"<<endl;
        //we can't move there. restore position
        car->setMatrix(originalCar);
        carRot->setMatrix(originalCarRot);
        cam_angle = original_cam_angle;

        cam_x = original_cam_x;
        cam_y = original_cam_y;
        cam_z = original_cam_z;

        lookat_x = original_lookat_x;
        lookat_y = original_lookat_y;
        lookat_z = original_lookat_z;
    }
    else{
        //cerr << "No collision??" << endl;
        // no collision so move the lookat point and redraw
        //calc new lookat position on unit circle
        lookat_x = cam_x + cos(d2r(cam_angle));
        lookat_z = (cam_z - sin(d2r(cam_angle)));


        glutPostRedisplay();
    }
    collisionDetected = false;
    displayCallback();

}


GLuint* WindowR::LoadTextures(string TexName[], int n_textures)
  {

   TGAImg Img;        // Image loader
   GLuint *Textures = (GLuint*)malloc(sizeof(GLuint) * n_textures);

	int i = 0;

	glGenTextures(n_textures,Textures);            // Allocate space for textures

	for (i = 0; i < n_textures; i++){

		cout << "Loading texture: " << TexName[i] << " into Tex#" << Textures[i] << endl;

	  // Load our Texture
	   if(Img.Load(TexName[i].c_str()) != IMG_OK){
	    	Textures[i] = -1;
			cout << "Image load failed!" << endl;
		}

	   glBindTexture(GL_TEXTURE_2D,Textures[i]); // Set our Tex handle as current

		//set params
		if (MIPMAPS)
			glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
			                 GL_LINEAR_MIPMAP_LINEAR );
		else
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		// when texture area is small, trilinear filter the two closest mipmaps
		//when larger bilinear filter original
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);

		int internalFormat=-1, type=-1;

		if (Img.GetBPP()==24){
			internalFormat = 3;
			type = GL_RGB;
		}else if(Img.GetBPP()==32){
			internalFormat = 4;
			type = GL_RGBA;
		}

	   // Create the texture
	    if(type != -1){
	    	if (MIPMAPS){	// create MipMaps
				gluBuild2DMipmaps( GL_TEXTURE_2D, internalFormat, Img.GetWidth(), Img.GetHeight(),
			                   type, GL_UNSIGNED_BYTE, Img.GetImg() );
			}else{
				glTexImage2D(GL_TEXTURE_2D,0,internalFormat,Img.GetWidth(),Img.GetHeight(),0,
		                  type,GL_UNSIGNED_BYTE,Img.GetImg());
			}

		}else{
	     	Textures[i] = -1;
		}


 	}

	return Textures;

}

void WindowR::initTextures(){


	string texNames[N_TEX] = {"textures/grass.tga", "textures/corner.tga", "textures/road.tga"};
	GLuint *tex = WindowR::LoadTextures(texNames, N_TEX);

	grass_tex = tex[0];
	corner_tex = tex[1];
	road_tex = tex[2];
	int i;
	string path("textures/scraper/");
	string BldgtexNames[N_BLDG_TEX];

	for (i = 0; i < N_BLDG_TEX; i++){
		stringstream out;
		out << (i+1);
		BldgtexNames[i] = (path + out.str() + ".tga");
	}
	//now load the skyscraper textures

	tex = WindowR::LoadTextures(BldgtexNames, N_BLDG_TEX);

	bldg_tex = tex;


	glEnable(GL_NORMALIZE);
	glEnable(GL_TEXTURE_2D);

	cout << "initTex: glError is: " << glGetError() << endl;


    glGenTextures(1, textureID);
    textureData_car = loadPPM("textures/uaz.ppm", car_width, car_height);
    glBindTexture(GL_TEXTURE_2D, textureID[0]);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
    glTexImage2D(GL_TEXTURE_2D,0,3,car_width,car_height,0,
    GL_RGB,GL_UNSIGNED_BYTE,textureData_car);

}


int main(int argc, char *argv[])
{

	srand(time(NULL));

	//ROOT = makeCityBlock();

 float specular[]  = {1.0, 1.0, 1.0, 1.0};
  float shininess[] = {20.0};

  glutInit(&argc, argv);      	      	      // initialize GLUT
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);   // open an OpenGL context with double buffering, RGB colors, and depth buffering
  glutInitWindowSize(WindowR::width, WindowR::height);      // set initial window size
  glutCreateWindow("SimCity 5");    	      // open window and set window title
  if (glutGet(GLUT_WINDOW_COLORMAP_SIZE) != 0)
  {
    cerr << "Fatal Error: bad RGBA colormap size\n" << endl;
    exit(1);
  }
  glEnable(GL_DEPTH_TEST);            	      // enable depth buffering
  glClear(GL_DEPTH_BUFFER_BIT);       	      // clear depth buffer
  glClearColor(0.0, 0.0, 0.8, 0.0);   	      // set clear color to dark blue
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);  // set polygon drawing mode to fill front and back of each polygon
  glShadeModel(GL_SMOOTH);             	      // set shading to smooth
  glMatrixMode(GL_PROJECTION);

  // Generate material properties:
  glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specular);
  glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, shininess);
  glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
  glEnable(GL_COLOR_MATERIAL);

	if (TEXTURING){
		WindowR::initTextures();
	}
	Matrix4 id;
	id.identity();
	GLOBALROOT = new transformGroup(id);
	ROOT = makeCityGrid(GRID_SIZE);
    car = new transformGroup;
    carRot = new transformGroup;

    Matrix4 tempTrans;
    Matrix4 tempRot;
    tempRot.rotateX(-90);
    tempTrans.rotateZ(180);
    tempRot.multiplyInPlace(tempTrans);
    tempTrans.scaling(.05,.05,.05);
    tempRot.multiplyInPlace(tempTrans);
    firstCar= new Shape3D("uaz.obj",tempRot);
    firstCar->setTexture(textureID[0]);
    tempTrans.translation(3,0,-2);
    carRot->setMatrix(tempTrans);
    car->addChild(firstCar);
    carRot->addChild(car);
    GLOBALROOT->addChild(carRot);
    GLOBALROOT->addChild(ROOT);

	sun.enable();
	sun.setDirectional(0,-1,0);		//straight down
	sun.setAmbient(0.2,0.2,0.2,1);
	sun.setDiffuse(1,1,1,1);
	sun.setSpecular(1,1,1,1);



  // Install callback functions:
  glutDisplayFunc(WindowR::displayCallback);
  glutReshapeFunc(WindowR::reshapeCallback);
  glutIdleFunc(WindowR::idleCallback);
  //glutMouseFunc(WindowR::mouseCallback);
  //glutMotionFunc(WindowR::motionCallback);
  glutKeyboardFunc(WindowR::keyboard);
  glutSpecialFunc(WindowR::specialFunc);
  // Initialize cube matrix:
  //sphere.getMatrix().identity(); //fix this
  tempM.identity();
  //rotM.identity();

	setupCamera();

 	//makeWndBounding();
  glutFullScreen();
  glutMainLoop();
  return 0;
}



void makeWndBounding(){

	Vector3 e;
  Vector3 d;
  Vector3 up;
  Vector3 right;
  e.set(5,0,20);
  d.set(0,0,-1);
  up.set(0,1,0);
  cam.set(e,d,up);
  right.cross(up,d);

  Matrix4 m3;
  m3 = cam.getMatrix();
  cam.cameraMatrix.invert();
  double fov = 1.04719755;
  double aspect = 1;
  double near_dist = 1;
  double far_dist = 100;
  f.set(fov,aspect,near_dist,far_dist);

    Vector3 temp;
  // calculate the bounding properties
    WindowR::Hnear = 2*tan(fov/2.0)*near_dist;
    WindowR::Wnear = WindowR::Hnear*aspect;

    //NEAR---------------------------------------------------
    WindowR::nNear.set(d.get(0),d.get(1),d.get(2));
    WindowR::nNear.normalize();
    WindowR::pNear.scale(near_dist,d);
    //WindowR::pNear.add(e);
    //WindowR::pNear.normalize();
    WindowR::dNear = WindowR::pNear.dot(WindowR::nNear);

    //FAR----------------------------------------------------
    WindowR::nFar.set(-1*d.get(0),-1*d.get(1),-1*d.get(2));
    WindowR::pFar.scale(far_dist,d);
    //WindowR::pFar.subtract(e);
    WindowR::nFar.normalize();
    //WindowR::pFar.normalize();
    WindowR::dFar = WindowR::pFar.dot(WindowR::nFar);

    //RIGHT--------------------------------------------------
    temp.scale(WindowR::Wnear/2.0,right);
    WindowR::pRight.subtract(WindowR::pNear,temp);
    //WindowR::pRight.subtract(e);
    WindowR::pRight.normalize();
    WindowR::nRight.cross(up,WindowR::pRight);
    WindowR::nRight.normalize();
    WindowR::dRight = WindowR::pRight.dot(WindowR::nRight);

    //LEFT---------------------------------------------------
    temp.scale(WindowR::Wnear/2.0,right);
    WindowR::pLeft.add(WindowR::pNear,temp);
    //WindowR::pLeft.subtract(e);
    WindowR::pLeft.normalize();
    WindowR::nLeft.cross(WindowR::pLeft,up);
    WindowR::nLeft.normalize();
    WindowR::dLeft = WindowR::pLeft.dot(WindowR::nLeft);

    //BOTTOM-------------------------------------------------
    temp.scale(WindowR::Hnear/2.0,up);
    WindowR::pBottom.subtract(WindowR::pNear,temp);
    //WindowR::pTop.subtract(e);
    WindowR::pBottom.normalize();
    WindowR::nBottom.cross(WindowR::pBottom,right);
    WindowR::nBottom.normalize();
    WindowR::dBottom = WindowR::pBottom.dot(WindowR::nBottom);

    //TOP----------------------------------------------------
    temp.scale(WindowR::Hnear/2.0,up);
    WindowR::pTop.add(WindowR::pNear,temp);
    //WindowR::pTop.subtract(e);
    WindowR::pTop.normalize();
    WindowR::nTop.cross(right,WindowR::pTop);
    WindowR::nTop.normalize();
    WindowR::dTop = WindowR::pTop.dot(WindowR::nTop);

}


/*
void WindowR::mouseCallback(int button, int state, int x, int y)
{
    mouseStartX = x;
    mouseStartY = y;
    mouseStartZ = sqrt((radius*radius)-((x-(width/2))*(x-(width/2)))-((y-(height/2))*(y-(height/2))));
    //mouseStartZ = sqrt((radius*radius)/(((x-(width/2))*(x-(width/2)))+((y-(height/2))*(y-(height/2)))));
    cout << "mouse clicked/unclicked"<< x <<","<< y << endl;
    //In mouseFunc, you set your house to that, and reset your arbRot.
    rotM.identity();
    houseM = tempM;
    WindowR::displayCallback();
}
void WindowR::motionCallback(int x, int y)
{
    Vector3 m0;
    Vector3 m1;
    Vector3 rotationAxis;
    int z = sqrt((radius*radius) - ((x-(width/2))*(x-(width/2)))-((y-(height/2))*(y-(height/2))));
    m0.set(mouseStartX-(width/2),-(mouseStartY-(height/2)),mouseStartZ);
    m1.set(x-(width/2),-(y-(height/2)),z);
    rotationAxis.cross(m0,m1);
    m0.normalize();
    m1.normalize();
    double dotProduct = m0.dot(m1);
    //cout << dotProduct << endl;
    double rotationAngle = acos(m0.dot(m1))*RtoD; //check if it should really be more than 180??? how
    //cout << rotationAngle << "dot" << dotProduct << endl;
    rotM.rotate(rotationAngle,rotationAxis);
    tempM = rotM.multiply(houseM);

    glMatrixMode(GL_MODELVIEW);
    //houseM = tempM; // THIS MIGHT BE BACKWARDS...
    glLoadMatrixd(tempM.getPointer()); //FIX THIS
    WindowR::displayCallback();

    //houseM = tempM;
    //mouseStartX = x;
    //mouseStartY = y;
    //mouseStartZ = sqrt((radius*radius)-((x-(width/2))*(x-(width/2)))-((y-(height/2))*(y-(height/2))));
    //mouseStartZ = sqrt((radius*radius)/(((x-(width/2))*(x-(width/2)))+((y-(height/2))*(y-(height/2)))));

    //You have a rotation matrix, which is created from the arbitrary rotation each time.
    //The third is the temp matrix: arbRot * house <IN THAT ORDER>
    //This temp matrix is tricky because in motionFunc, you load that as your glLoadMatrixd
}

*/
