#include "../global.h"

Camera::Camera()
{
   cameraMatrix.set(3,3,1);
}

Camera::Camera(Vector3 e,Vector3 d,Vector3 up){
    this->e = e;
    this->d = d;
    this->up = up;
    setupMatrix();
}

Vector3 Camera::getD(){
    return d;
}
Vector3 Camera::getE(){
    return e;
}
Vector3 Camera::getUp(){
    return up;
}
Matrix4 Camera::getMatrix(){
    return cameraMatrix;
}

void Camera::setD(Vector3 d){
    this->d = d;
    /* Fix matrix */
    setupMatrix();
}
void Camera::setE(Vector3 e){
    this->e = e;
    /* Fix matrix */
    setupMatrix();
}
void Camera::setUp(Vector3 up){
    this->up = up;
    /* Fix matrix */
    setupMatrix();
}
void Camera::set(Vector3 e,Vector3 d,Vector3 up){
    this->e = e;
    this->d = d;
    this->up = up;
    /* Fix matrix */
    setupMatrix();
}
void Camera::setupMatrix(){
    /* Note, d,e, up are wrong if you do this */
    Vector3 temp = e-d;
    temp.normalize();
    //double magnitude;
    //magnitude = temp.magnitude();
    //temp.scale((1/temp.magnitude()));
    Vector3 z = temp;

    //normalize z???

    temp.cross(up,z);
    temp.normalize();
    //magnitude = temp.magnitude();
    //temp.scale(1/temp.magnitude());
    Vector3 x = temp;

    // normalize x???

    temp.cross(z,x);
    Vector3 y = temp;
    /* this may be backwards */
    cameraMatrix.set(0,0,x.get(0));
    cameraMatrix.set(1,0,y.get(0));
    cameraMatrix.set(2,0,z.get(0));
    cameraMatrix.set(3,0,e.get(0));
    cameraMatrix.set(0,1,x.get(1));
    cameraMatrix.set(1,1,y.get(1));
    cameraMatrix.set(2,1,z.get(1));
    cameraMatrix.set(3,1,e.get(1));
    cameraMatrix.set(0,2,x.get(2));
    cameraMatrix.set(1,2,y.get(2));
    cameraMatrix.set(2,2,z.get(2));
    cameraMatrix.set(3,2,e.get(2));
    cameraMatrix.set(0,3,0);
    cameraMatrix.set(1,3,0);
    cameraMatrix.set(2,3,0);
    cameraMatrix.set(3,3,1);
}
