#include "../global.h"

Frustum::Frustum(){
    fov = 0;
    aspect = 0;
    near = 0;
    far = 0;
}
Frustum::Frustum(double fo,double a,double n,double f){
    fov = fo;
    aspect = a;
    near = n;
    far = f;
    setupMatrix();
}
double Frustum::getFov(){
    return fov;
}
double Frustum::getAspect(){
    return aspect;
}
double Frustum::getNear(){
    return near;
}
double Frustum::getFar(){
    return far;
}
void Frustum::setFov(double f){
    fov = f;
    setupMatrix();
}
void Frustum::setAspect(double a){
    aspect =a;
    setupMatrix();
}
void Frustum::setNear(double n){
    near = n;
    setupMatrix();
}
void Frustum::setFar(double f){
    far = f;
    setupMatrix();
}
void Frustum::set(double fo,double a,double n, double fa){
    fov = fo;
    aspect = a;
    near = n;
    far = fa;
    setupMatrix();
}
void Frustum::setupMatrix(){
    //implement this
    frustumMatrix.set(0,0,(1/(aspect*tan(fov/2))));
    frustumMatrix.set(1,0,0);
    frustumMatrix.set(2,0,0);
    frustumMatrix.set(3,0,0);

    frustumMatrix.set(0,1,0);
    frustumMatrix.set(1,1,(1/(tan(fov/2))));
    frustumMatrix.set(2,1,0);
    frustumMatrix.set(3,1,0);

    frustumMatrix.set(0,2,0);
    frustumMatrix.set(1,2,0);
    frustumMatrix.set(2,2,((near+far)/(near-far)));
    frustumMatrix.set(3,2,((2*near*far)/(near-far)));

    frustumMatrix.set(0,3,0);
    frustumMatrix.set(1,3,0);
    frustumMatrix.set(2,3,-1);
    frustumMatrix.set(3,3,0);
}
void Frustum::setGLProjection(){
    //implement this
    glMatrixMode(GL_PROJECTION);
    glLoadMatrixd(frustumMatrix.getPointer());
    glMatrixMode(GL_MODELVIEW);
}
