#ifndef _MATRIX4_H_
#define _MATRIX4_H_


class Matrix4
{
  protected:
    double m[4][4];   // matrix elements

  public:
    Matrix4();        // constructor
    Matrix4(double, double, double, double, double, double, double, double, double, double, double, double, double, double, double, double);

	void set(int column, int row, double value);
	double get(int column, int row);
	Matrix4 multiply(Matrix4 &a);
	void multiplyInPlace(Matrix4 &a);
	Vector3 multiplyVector(Vector3 &a);
	Vector4 multiplyVectorPromote(Vector3 &a);
	Vector4 multiplyVector(Vector4 &a);

    double* getPointer();  // return pointer to matrix elements
    void identity();  // create identity matrix

	void rotateX(double angle); // rotation about x axis
    void rotateY(double angle); // rotation about y axis
	void rotateZ(double angle); // rotation about z axis
	void rotate(double angle, Vector3 &a);
	void rotate(double angle, Vector4 &a);
	void scaling(double x0, double y0, double z0);
	void translation(double x0, double y0, double z0);
	void invert();
	Matrix4 getInverse();

};

#endif
