#ifndef VECTOR3_H_INCLUDED
#define VECTOR3_H_INCLUDED

class Vector3 {
    public:
        double x,y,z;//coordinates

        Vector3();//empty constructor
        Vector3(double x0,double y0,double z0);//constructor that sets coordinates

        void set(double x0,double y0,double z0);//set coordinates
        double get(int point);//0=x,1=y,2=z
        double operator[](int point);//0=x,1=y,2=z

        void add(Vector3 &a);//add vectors together (+=)
        void add(Vector3 &a,Vector3 &b);//add two vectors and save them as this
        Vector3 operator+(Vector3 &a);

        void subtract(Vector3 &a);//subtract a vector from this (-=)
        void subtract(Vector3 &a,Vector3 &b);//subtract two vectors and save them as this
        Vector3 operator-(Vector3 &a);

        void scale(double s);//scale vector by s
        void scale(double s,Vector3 &a);// scale a by s and save as this
        double dot(Vector3 &a);//dot product of this and a return it...
        void cross(Vector3 &a,Vector3 &b);//cross product of two vectors saved as this
        double magnitude();//return the magnitude of the vector
        void normalize();//normalize this vector
        void setZ(int newZ);
};



#endif // VECTOR3_H_INCLUDED
