#ifndef VECTOR4_H_INCLUDED
#define VECTOR4_H_INCLUDED

class Vector4 {
    public:
        double x,y,z,w;//coordinates

        Vector4();//empty constructor
        Vector4(double x0,double y0,double z0,double w0=0);//constructor that sets coordinates

        void set(double x0,double y0,double z0, double w0=0);//set coordinates
        double get(int point);//0=x,1=y,2=z
        double operator[](int point);//0=x,1=y,2=z

        void add(Vector4 &a);//add vectors together (+=)
        void add(Vector4 &a,Vector4 &b);//add two vectors and save them as this
        Vector4 operator+(Vector4 &a);

        void subtract(Vector4 &a);//subtract a vector from this (-=)
        void subtract(Vector4 &a,Vector4 &b);//subtract two vectors and save them as this
        Vector4 operator-(Vector4 &a);

		void dehomogenize();
};



#endif // VECTOR4_H_INCLUDED
