#ifndef GLOBAL_H_INCLUDED
#define GLOBAL_H_INCLUDED


#ifdef _WIN32
  	#include <windows.h>
	#include <GL/glut.h>
	#include <GL/gl.h>
#else
	#include <GL/glut.h>
#endif


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <time.h>
#include <iostream>
#include <sstream>
#include <ostream>
#include <vector>
#include <string.h>

#include "defines.h"

//base includes
#include "basic/basic.h"

//object reader includes
#include "loader/loader.h"

//scene graph stuff
#include "scene/scene.h"


//shapes things
#include "shapes/shapes.h"

//tree
#include "tree/fractal_tree.h"


//the main program
#include "WindowR.h"

//some forward func declarations, just coz im lazy
transformGroup *makeCityBlock();
transformGroup *makeCityGrid(int);


//static bool robot = false;
static bool culling = false;

#define DEG2RAD (M_PI/180.0)
inline double d2r(double d){return d*DEG2RAD;}
inline double unitRnd(){return ((double)rand()/RAND_MAX);}

static double dNear;
static double dFar;
static double dRight;
static double dLeft;
static double dTop;
static double dBottom;

static Vector3 pNear;
static Vector3 pFar;
static Vector3 pRight;
static Vector3 pLeft;
static Vector3 pTop;
static Vector3 pBottom;

static Vector3 nNear;
static Vector3 nFar;
static Vector3 nRight;
static Vector3 nLeft;
static Vector3 nTop;
static Vector3 nBottom;

//double Hfar;
//double Wfar;
static double Hnear;
static double Wnear;
static bool collisions = false;
#endif // GLOBAL_H_INCLUDED
