#include "../global.h"
using namespace std;

loadObject::loadObject(void)
{
        scaleM.identity();
        minX = -DBL_MAX;
        minY = -DBL_MAX;
        minZ = -DBL_MAX;
        maxX = DBL_MAX;
        maxY = DBL_MAX;
        maxZ = DBL_MAX;
}

loadObject::loadObject(loadObject* o){ //copy constructor
    nVerts = o->nVerts;
    nIndices = o->nIndices;
    minX = o->minX;
    minY = o->minY;
    minZ = o->minZ;
    maxX = o->maxX;
    maxY = o->maxY;
    maxZ = o->maxZ;
    scaleM = o->scaleM;
        //float *vertices;
        //float *normals;
        //float *texcoords;
        //int *indices;
    cerr<<"cc number of verts:"<<nVerts<<endl;
    cerr<<"cc number of index:"<<nVerts<<endl;
    vertices = new float [nVerts*3];
    indices = new int [nIndices+1];
    normals = new float [nVerts*3];
    texcoords = new float [nVerts*2];
    memcpy(vertices, o->vertices, sizeof(float)*(nVerts*3));
    memcpy(indices, o->indices, sizeof(int)*(nIndices));
    memcpy(normals, o->normals, sizeof(float)*(nVerts*3));
    memcpy(texcoords, o->texcoords, sizeof(float)*(nVerts*2));
}
loadObject::loadObject(char* infile){
    cout << infile << endl;
    filename = infile;
}
void loadObject::readObject(){

    ObjReader::readObj(filename, nVerts, &vertices, &normals, &texcoords, nIndices, &indices);
    cout << "read # verts: " << nVerts << endl;
    cout << "read # indecies: " << nIndices << endl;
    scaleM.scaling(10,10,10);

    for(int i=0; i<nIndices; i++){
        if(minX>vertices[indices[i]*3]){
            minX = vertices[indices[i]*3];
        }
        if(maxX<vertices[indices[i]*3]){
            maxX = vertices[indices[i]*3];
        }
        if(minY>vertices[indices[i]*3+1]){
            minY = vertices[indices[i]*3+1];
        }
        if(maxY<vertices[indices[i]*3+1]){
            maxY = vertices[indices[i]*3+1];
        }
        if(minZ>vertices[indices[i]*3+2]){
            minZ = vertices[indices[i]*3+2];
        }
        if(maxZ<vertices[indices[i]*3+2]){
            maxZ = vertices[indices[i]*3+2];
        }
    }
}
void loadObject::normalize(double width, double height, double depth){
    double objHeight = maxY-minY;
    double scaleFactor = (height)/objHeight;
    double objWidth = maxX-minX;
    double objDepth = maxZ-minZ;

    cout << "X:" << maxX <<":"<< minX << endl;
    cout << "Y:" << maxY <<":"<< minY << endl;
    cout << "Z:" << maxZ <<":"<< minZ << endl;


    cout << "width:" <<objWidth << endl;
    cout << "height:" <<objWidth << endl;
    cout << "depth:" <<objWidth << endl;
    if(width/objWidth <scaleFactor){
        scaleFactor = (width)/objWidth;
    }
    cout << "scaleFactor:" <<scaleFactor << endl;
    Matrix4 m;
    scaleM.translation(((0-(maxX+minX)/2)*scaleFactor/15.5),((0-(maxY+minY)/2)*scaleFactor/15.5),((0-(maxZ+minZ)/2)*scaleFactor/15.5));
    cout <<"transX"<< (0-(maxX+minX)/2) <<endl;
    cout <<"transY"<< (0-(maxY+minY)/2) <<endl;
    cout <<"transZ"<< (0-(maxZ+minZ)/2) <<endl;

    m.scaling(scaleFactor/15.5,scaleFactor/15.5,scaleFactor/15.5);
    scaleM.multiplyInPlace(m);
}

void loadObject::setFile(char* infile){
    cout << infile << endl;
    filename = infile;
}
void loadObject::setTexture(GLuint t){
    textureID = t;
}
void loadObject::drawObject(){
      // Draw sides of cube in object coordinate system:
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, textureID);
  glBegin(GL_TRIANGLES);
        //double red = .01;
        //double green = .11;
        //double blue = .21;
		for (int i=0; i<nIndices; i++)
		{
		    //cout<<"itt:"<<i<< endl;
			//glColor3f(red,green,blue);
            glTexCoord2f(texcoords[indices[i]*2],texcoords[indices[i]*2+1]);
            glNormal3f(normals[indices[i]*3],normals[indices[i]*3+1],normals[indices[i]*3+2]);
            //cout<<normals[0]<< endl;
            //cout<<texcoords[0]<<endl;
            glVertex3f(vertices[indices[i]*3],vertices[indices[i]*3+1],vertices[indices[i]*3+2]);


			//glVertex3f(vertices[indices[i]*3],vertices[indices[i]*3+1],vertices[indices[i]*3+2]);
			//glVertex3f(vertices[indices[i+1]*3],vertices[indices[i+1]*3+1],vertices[indices[i+1]*3+2]);
			//glVertex3f(vertices[indices[i+2]*3],vertices[indices[i+2]*3+1],vertices[indices[i+2]*3+2]);
		}
  glBindTexture(GL_TEXTURE_2D, 0);
  glDisable(GL_TEXTURE_2D);
  glEnd();
}
