#ifndef LOADOBJECT_H_INCLUDED
#define LOADOBJECT_H_INCLUDED


class loadObject {
    public:
        char* filename;
        double minX;
        double minY;
        double minZ;
        double maxX;
        double maxY;
        double maxZ;
        Matrix4 scaleM;
        GLuint textureID;

        int nVerts;
        float *vertices;
        float *normals;
        float *texcoords;
        int nIndices;
        int *indices;

        loadObject(loadObject* o);
        loadObject();//empty constructor
        loadObject(char* infile);
        void readObject();
        void setFile(char* infile);
        void drawObject();
        void normalize(double width, double height, double depth);
        void setTexture(GLuint t);

};

#endif // LOADOBJECT_H_INCLUDED
