#include "../global.h"
using namespace std;
Node::Node(){
    //do nothing for now
}
//Vector3 P0, Vector3 P1, Vector3 Normal, Vector3 Vector
bool Node::segmentPlaneIntersect(Vector3 P0, Vector3 P1, Vector3 normal, Vector3 v0, Vector3 v1, Vector3 v2, Vector3 v3){
    Vector3    u = P1 - P0;
    Vector3    w = P0 - v0;

    float     D = normal.dot(u);
    float     N = -normal.dot(w);

    if (fabs(D) < 0.00000001) {          // segment is parallel to plane
        if (N == 0){                     // segment lies in plane
            //return 2;
            //return true;
            cout <<"in plane"<<endl;
            return false;
        }
        else{
            //return 0;                   // no intersection
            return false;
        }
    }
    // they are not parallel
    // compute intersect param
    double sI = N / D;
    if (sI < 0 || sI > 1){
        //return 0;                       // no intersection
        return false;
    }
    u.scale(sI);
    Vector3 intersection = P0 + u; //this is the intersection point
    return(PointInSquare(intersection,v0,v1,v2,v3));
}


bool Node::SameSide(Vector3 p1,Vector3 p2, Vector3 a,Vector3 b){
    Vector3 cp1;
    Vector3 ba = b - a;
    Vector3 p1a = p1-a;
    Vector3 p2a = p2-a;
    cp1.cross(ba, p1a);
    Vector3 cp2;
    cp2.cross(ba, p2a);
    if (cp1.dot(cp2) >= 0){
        return true;
    }
    else{
        return false;
    }
}

bool Node::PointInSquare(Vector3 p,Vector3 a,Vector3 b,Vector3 c,Vector3 d){
    cerr <<"PP0:"<< a.get(0)<<":"<<a.get(1)<<":"<<a.get(2)<< endl;
    cerr <<"PP1:"<< b.get(0)<<":"<<b.get(1)<<":"<<b.get(2)<< endl;
    cerr <<"PP2:"<< c.get(0)<<":"<<c.get(1)<<":"<<c.get(2)<< endl;
    cerr <<"PP3:"<< d.get(0)<<":"<<d.get(1)<<":"<<d.get(2)<< endl;
    cerr <<"Compare:"<< p.get(0)<<":"<<p.get(1)<<":"<<p.get(2)<< endl;
    if(SameSide(p,a, b,d) && SameSide(p,c, b,a) && SameSide(p,d,c,b)&& SameSide(p,d,a,c)){
        return true;
    }
    else{
        cerr <<"PP0:"<< SameSide(p,a,b,d)<< endl;
        cerr <<"PP1:"<< SameSide(p,c,b,a)<< endl;
        cerr <<"PP2:"<< SameSide(p,d,c,b)<< endl;
        cerr <<"PP3:"<< SameSide(p,d,a,c) << endl;
        return false;
    }
}
