#include "../global.h"

using namespace std;
void Shape3D::draw(Matrix4 m){
   	glPushMatrix();

	glMatrixMode(GL_MODELVIEW);
	//now set matrix
	m.multiplyInPlace(transM);
	glMultMatrixd(m.getPointer());

	 glPushAttrib(GL_ALL_ATTRIB_BITS); // Pushes attributes like current color to attribute stack.

    double distance;
    if(WindowR::culling){
        calculateSphere(m);//calculate the sphere
        Vector3 myCenter(centerX,centerY,centerZ);


        //cull near-----------------------
        //cerr<< "s-X:Y:Z:"<<myCenter.get(0)<<":"<<myCenter.get(1)<<":"<<myCenter.get(2)<<endl;
        distance = myCenter.dot(WindowR::nNear);
        //cerr<< "f-X:Y:Z:"<<WindowR::nNear.get(0)<<":"<<WindowR::nNear.get(1)<<":"<<WindowR::nNear.get(2)<<endl;
        distance -= WindowR::dNear;
        if(distance<-radius){
            cerr<<"culled"<<endl;
            //cerr<<"outside of near"<<endl;
            //cerr<< "distance:radius"<<distance<<":"<<radius<<endl;
            //cerr<< "dNear is "<<WindowR::dNear<<endl;
            return;
        }


        //cull far------------------------
        //cerr<< "s-X:Y:Z:"<<myCenter.get(0)<<":"<<myCenter.get(1)<<":"<<myCenter.get(2)<<endl;
        distance = myCenter.dot(WindowR::nFar);
        //cerr<< "dist:"<<distance<<endl;
        //cerr<< "f-X:Y:Z:"<<WindowR::nFar.get(0)<<":"<<WindowR::nFar.get(1)<<":"<<WindowR::nFar.get(2)<<endl;
        distance -= WindowR::dFar;
        if(distance<-radius){
            cerr<<"culled"<<endl;
            //cerr<<"outside of far"<<endl;
            //cerr<< "distance:radius"<<distance<<":"<<radius<<endl;
            //cerr<< "dFar is "<<WindowR::dFar<<endl;
            return;
        }


        //cull right------------------------
        //cerr<< "s-X:Y:Z:"<<myCenter.get(0)<<":"<<myCenter.get(1)<<":"<<myCenter.get(2)<<endl;
        distance = myCenter.dot(WindowR::nRight);
        //cerr<< "dist:"<<distance<<endl;
        //cerr<< "f-X:Y:Z:"<<WindowR::nFar.get(0)<<":"<<WindowR::nFar.get(1)<<":"<<WindowR::nFar.get(2)<<endl;
        distance -= WindowR::dRight;
        if(distance<-radius){
            cerr<<"culled"<<endl;
            //cerr<<"outside of far"<<endl;
            //cerr<< "distance:radius"<<distance<<":"<<radius<<endl;
            //cerr<< "dRight is "<<WindowR::dRight<<endl;
            return;
        }
        else{
            //cerr<< "dRight is "<<WindowR::dRight<<endl;
        }

        //cull left------------------------
        //cerr<< "s-X:Y:Z:"<<myCenter.get(0)<<":"<<myCenter.get(1)<<":"<<myCenter.get(2)<<endl;
        distance = myCenter.dot(WindowR::nLeft);
        //cerr<< "dist:"<<distance<<endl;
        //cerr<< "f-X:Y:Z:"<<WindowR::nFar.get(0)<<":"<<WindowR::nFar.get(1)<<":"<<WindowR::nFar.get(2)<<endl;
        distance -= WindowR::dLeft;
        if(distance<-radius){
            cerr<<"culled"<<endl;
            //cerr<<"outside of far"<<endl;
            //cerr<< "distance:radius"<<distance<<":"<<radius<<endl;
            //cerr<< "dLeft is "<<WindowR::dLeft<<endl;
            return;
        }
        else{
            //cerr<< "dLeft is "<<WindowR::dLeft<<endl;
        }

        //cull bottom------------------------
        //cerr<< "s-X:Y:Z:"<<myCenter.get(0)<<":"<<myCenter.get(1)<<":"<<myCenter.get(2)<<endl;
        distance = myCenter.dot(WindowR::nBottom);
        //cerr<< "dist:"<<distance<<endl;
        //cerr<< "f-X:Y:Z:"<<WindowR::nFar.get(0)<<":"<<WindowR::nFar.get(1)<<":"<<WindowR::nFar.get(2)<<endl;
        distance -= WindowR::dBottom;
        if(distance<-radius){
            cerr<<"culled"<<endl;
            //cerr<<"outside of far"<<endl;
            //cerr<< "distance:radius"<<distance<<":"<<radius<<endl;
            //cerr<< "dBottom is "<<WindowR::dBottom<<endl;
            return;
        }
        else{
            //cerr<< "dBottom is "<<WindowR::dBottom<<endl;
        }

        //cull top------------------------
        //cerr<< "s-X:Y:Z:"<<myCenter.get(0)<<":"<<myCenter.get(1)<<":"<<myCenter.get(2)<<endl;
        distance = myCenter.dot(WindowR::nTop);
        //cerr<< "dist:"<<distance<<endl;
        //cerr<< "f-X:Y:Z:"<<WindowR::nFar.get(0)<<":"<<WindowR::nFar.get(1)<<":"<<WindowR::nFar.get(2)<<endl;
        distance -= WindowR::dTop;
        if(distance<-radius){
            cerr<<"culled"<<endl;
            //cerr<<"outside of far"<<endl;
            //cerr<< "distance:radius"<<distance<<":"<<radius<<endl;
            //cerr<< "dTop is "<<WindowR::dTop<<endl;
            return;
        }
        else{
            //cerr<< "dTop is "<<WindowR::dTop<<endl;
        }

    }

    //glLoadMatrixd(m.getPointer());
    //calculate radius
    //calculate center
    //decide if we should cull. if not draw it
    lobj->drawObject();
    //update center and
    glPopAttrib();
	glPopMatrix();
}
void Shape3D::center(){
    Matrix4 m;
    m.translation((0-(lobj->maxX+lobj->minX)/2),(0-(lobj->maxY+lobj->minY)/2),(0-(lobj->maxZ+lobj->minZ)/2));
    m.multiplyInPlace(transM);
    transM = m;
    //transM.multiplyInPlace(m);
}
Shape3D::Shape3D(char* infile){
    radius = -DBL_MAX;
    lobj = new loadObject(infile);
    lobj->readObject();
    transM.identity();
    //center();
}
Shape3D::Shape3D(Shape3D* copyShape){
    radius = -DBL_MAX;
    cerr << "Copy constructor!!!!!!!!!!!!!!!!!" << endl;
    lobj = new loadObject(copyShape->lobj);
    transM.identity();
    //center();
}
Shape3D::Shape3D(char* infile, Matrix4 m){
    radius = -DBL_MAX;
    lobj = new loadObject(infile);
    lobj->readObject();
    transM = m;
    //center();
}
Shape3D::Shape3D(Shape3D* copyShape,Matrix4 m){
    radius = -DBL_MAX;
    cerr << "Copy constructor!!!!!!!!!!!!!!!!!" << endl;
    lobj = new loadObject(copyShape->lobj);
    transM = m;
    //center();
}
void Shape3D::setTexture(GLuint t){
    lobj->setTexture(t);
}
void Shape3D::calculateSphere(Matrix4 m){
    double tempRadius;
    //X
    Vector3 vMax(lobj->maxX,0,0);
    Vector3 vMin(lobj->minX,0,0);
    Vector3 rtnMax;
    Vector3 rtnMin;
    rtnMax = m.multiplyVector(vMax);
    rtnMin = m.multiplyVector(vMin);
    centerX = (rtnMax.get(0) + rtnMin.get(0))/(2.0);
    tempRadius = fabs((rtnMax.get(0) - rtnMin.get(0))/(2.0));
    if(tempRadius>radius){
        radius = tempRadius;
    }
    //Y
    vMax.set(0,lobj->maxY,0);
    vMin.set(0,lobj->minY,0);
    rtnMax = m.multiplyVector(vMax);
    rtnMin = m.multiplyVector(vMin);
    centerY = (rtnMax.get(1) + rtnMin.get(1))/2.0;

    tempRadius = fabs((rtnMax.get(1) - rtnMin.get(1))/2.0);
    if(tempRadius>radius){
        radius = tempRadius;
    }
    //Z
    vMax.set(0,0,lobj->maxZ);
    vMin.set(0,0,lobj->minZ);
    rtnMax = m.multiplyVector(vMax);
    rtnMin = m.multiplyVector(vMin);
    centerZ = (rtnMax.get(2) + rtnMin.get(2))/2.0;
    tempRadius = fabs((rtnMax.get(2) - rtnMin.get(2))/2.0);
    if(tempRadius>radius){
        radius = tempRadius;
    }
    /*
    cerr<<"Radius:"<<radius<<endl;
    cerr<<"Center X:"<<centerX<<endl;
    cerr<<"Center Y:"<<centerY<<endl;
    cerr<<"Center Z:"<<centerZ<<endl;
    */
}

void Shape3D::detectCollision(Node* in,Matrix4 inTransforms, Matrix4 m){
    //TODO FIX!!!
    return;
}
