#include "../global.h"
//Textures
extern int corner_tex;


#define TEX_COORD	2

using namespace std;

Corner::Corner(){
    transM.identity();
}

Corner::Corner(Matrix4 m){
    transM = m;
}

void Corner::draw(Matrix4 m){

	//bind grass texture
   	glPushMatrix();

	glMatrixMode(GL_MODELVIEW);
	//now set matrix
	m.multiplyInPlace(transM);
	glMultMatrixd(m.getPointer());

	//just a draw a single flat quadratic shape, assigning textture coords as well
	//into the z-axis, on x-z plane
	 glPushAttrib(GL_ALL_ATTRIB_BITS);
						// Pushes attributes like current color to attribute stack.



	if (TEXTURING){
		glBindTexture(GL_TEXTURE_2D,corner_tex);
	     glColor3f(1, 1, 1);
	}else
		glColor3f(1, 0, 0);

	glBegin(GL_QUADS);

								// red
			glNormal3f(0, 1, 0);

			//lower left corner
			glTexCoord2f(0,0);
		     glVertex3f(0, 0, 0);

			//far left corner
		     glTexCoord2f(TEX_COORD,0);
			glVertex3f(0, 0, -CORNER_SIZE);

			//far right corner
		    glTexCoord2f(TEX_COORD,TEX_COORD);
			 glVertex3f(CORNER_SIZE, 0, -CORNER_SIZE);

			//lower right corner
		     glTexCoord2f(0,TEX_COORD);
			glVertex3f(CORNER_SIZE, 0, 0);

	 glEnd();


	 glPopAttrib();
	glPopMatrix();

	glBindTexture(GL_TEXTURE_2D,0);


}

void Corner::detectCollision(Node* in,Matrix4 inTransforms, Matrix4 m){
    //do nothing for now. nothing can collide with the ground at the point
    return;
}
