#include "../global.h"

//Textures
extern int grass_tex;
#define TEX_COORD	20


using namespace std;

Field::Field(){
    transM.identity();
}

Field::Field(Matrix4 m){
    transM = m;
}

void Field::draw(Matrix4 m){
	//cout << "Field.draw called!" << endl;

   	glPushMatrix();

	glMatrixMode(GL_MODELVIEW);
	//now set matrix
	m.multiplyInPlace(transM);
	glMultMatrixd(m.getPointer());


	//just a draw a single flat quadratic shape, assigning textture coords as well
	//into the z-axis, on x-z plane
	 glPushAttrib(GL_ALL_ATTRIB_BITS);	// Pushes attributes like current color to attribute stack.

	//bind grass texture


	if (TEXTURING){
		glBindTexture(GL_TEXTURE_2D,grass_tex);
	     glColor3f(1, 1, 1);
	}else
		glColor3f(0, 1, 0);


	glBegin(GL_QUADS);

		glNormal3f(0, 1, 0);

		//lower left corner
		 glTexCoord2f(0,0);
	     glVertex3f(0, 0, 0);

		//far left corner
	     glTexCoord2f(TEX_COORD,0);
		 glVertex3f(0, 0, -FIELD_LENGTH);

		//far right corner
	     glTexCoord2f(TEX_COORD,TEX_COORD);
		 glVertex3f(FIELD_WIDTH, 0, -FIELD_LENGTH);

		//lower right corner
	     glTexCoord2f(0,TEX_COORD);
		 glVertex3f(FIELD_WIDTH, 0, 0);

	 glEnd();

	 glPopAttrib();
	 glPopMatrix();
//	cout << "after Field.draw glEnd: glError is: " << glGetError() << endl;


	//unbind texture
	glBindTexture(GL_TEXTURE_2D,0);

}
void Field::detectCollision(Node* in,Matrix4 inTransforms, Matrix4 m){
    //do nothing for now. nothing can collide with the cround at the point
    return;
}
