#include "../global.h"
extern int road_tex;
#define TEX_COORD	8
using namespace std;

Street::Street(){
    transM.identity();
}

Street::Street(Matrix4 m){
    transM = m;
}

void Street::draw(Matrix4 m){
	//cout << "Street.draw called!" << endl;

	glPushMatrix();

	glMatrixMode(GL_MODELVIEW);
	//now set matrix
	m.multiplyInPlace(transM);
	glMultMatrixd(m.getPointer());

	//glLoadMatrixd(m.getPointer());

	//just a draw a single flat quadratic shape, assigning textture coords as well
	//into the z-axis, on x-z plane
	 glPushAttrib(GL_ALL_ATTRIB_BITS);
						// Pushes attributes like current color to attribute stack.

	if (TEXTURING){
		glBindTexture(GL_TEXTURE_2D,road_tex);
	    glColor3f(1, 1, 1);
	}else
		glColor3f(0, 0, 0);

	glBegin(GL_QUADS);
						// white
    	glNormal3f(0, 1, 0);

		//lower left corner
		glTexCoord2f(0,0);
	     glVertex3f(0, 0, 0);

		//far left corner
	     glTexCoord2f(TEX_COORD,0);
		glVertex3f(0, 0, -STREET_LENGTH);

		//far right corner
	    glTexCoord2f(TEX_COORD,1);
		 glVertex3f(STREET_WIDTH, 0, -STREET_LENGTH);

		//lower right corner
	     glTexCoord2f(0,1);
		glVertex3f(STREET_WIDTH, 0, 0);

	 glEnd();
	 glPopAttrib();
	glPopMatrix();

	glBindTexture(GL_TEXTURE_2D,0);


}
void Street::detectCollision(Node* in,Matrix4 inTransforms, Matrix4 m){
    //do nothing for now. nothing can collide with the cround at the point
    return;
}
